'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x2, _x3, _x4) { var _again = true; _function: while (_again) { var object = _x2, property = _x3, receiver = _x4; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x2 = parent; _x3 = property; _x4 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _reactPureRenderFunction = require('react-pure-render/function');

var _reactPureRenderFunction2 = _interopRequireDefault(_reactPureRenderFunction);

var _baconjs = require('baconjs');

var _baconjs2 = _interopRequireDefault(_baconjs);

var _createAction = require('./createAction');

var _createAction2 = _interopRequireDefault(_createAction);

var _isProperty = require('./isProperty');

var _isProperty2 = _interopRequireDefault(_isProperty);

var isReactComponent = function isReactComponent(c) {
  return c && c.prototype && typeof c.prototype.render === 'function';
};

var createBaconComponent = function createBaconComponent(mapProps, renderOrComponent) {
  var shouldPassThroughProps = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

  var _render = isReactComponent(renderOrComponent) ? function (props) {
    return (0, _react.createElement)(renderOrComponent, props);
  } : renderOrComponent;

  return (function (_Component) {
    _inherits(_class, _Component);

    function _class(props, context) {
      var _this = this;

      _classCallCheck(this, _class);

      _get(Object.getPrototypeOf(_class.prototype), 'constructor', this).call(this, props, context);

      this.shouldComponentUpdate = _reactPureRenderFunction2['default'];
      this.receive = (0, _createAction2['default'])();

      this.propsP = this.receive.$.map(function (x) {
        return x[0];
      }).startWith(props).toProperty();
      this.contextP = this.receive.$.map(function (x) {
        return x[1];
      }).startWith(context).toProperty();

      this.setComponentHasMounted = (0, _createAction2['default'])();

      this.componentHasMountedP = this.setComponentHasMounted.$.skipDuplicates().startWith(false).toProperty();

      this.subscriptions = [];

      this.addSubscription = function (subscription) {
        return _this.subscriptions.push(subscription);
      };

      this.childPropsP = mapProps(this.propsP, this.contextP, this.componentHasMountedP, this.addSubscription);

      if (shouldPassThroughProps) {
        this.childPropsP = (0, _isProperty2['default'])(this.childPropsP) ? this.childPropsP.combine(this.propsP, function (childProps, props) {
          return _extends({}, props, childProps);
        }) : this.propsP;
      }

      if ((0, _isProperty2['default'])(this.childPropsP)) {
        var subscribeP = _baconjs2['default'].combineTemplate({
          childProps: this.childPropsP,
          componentHasMounted: this.componentHasMountedP
        });

        this.unsubscribe = subscribeP.onValue(function (_ref) {
          var childProps = _ref.childProps;
          var componentHasMounted = _ref.componentHasMounted;
          return componentHasMounted ? _this.setState(childProps) : _this.state = childProps;
        });
      }
    }

    _createClass(_class, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        this.setComponentHasMounted(true);
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps, nextContext) {
        this.receive([nextProps, nextContext]);
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.subscriptions.forEach(function (unsubscribe) {
          return unsubscribe();
        });
        if (typeof this.unsubscribe === 'function') {
          this.unsubscribe();
        }
      }
    }, {
      key: 'render',
      value: function render() {
        return _render(this.state);
      }
    }]);

    return _class;
  })(_react.Component);
};

var curry = function curry(func) {
  return function (a, b, c) {
    return typeof b === 'undefined' ? function (d) {
      return func(a, d, c);
    } : func(a, b, c);
  };
};

exports['default'] = curry(createBaconComponent);
module.exports = exports['default'];